package Graph.ADTPackage;
/**
 * A class that implements the ADT priority queue by using a maxheap.
 * 
 * @author Frank M. Carrano
 * @version 2.0
 */
public class PriorityQueue<T extends Comparable<? super T>> 
             implements PriorityQueueInterface<T>, java.io.Serializable
{
	private MaxHeapInterface<T> pq;	
	
	public PriorityQueue()
	{
		pq = new MaxHeap<T>();
	} // end default constructor
	
	public PriorityQueue(int initialCapacity)
	{
		pq = new MaxHeap<T>(initialCapacity);
	} // end constructor

	public void add(T newEntry)
	{ 
		pq.add(newEntry);
	} // end add

	public T remove()
	{
		return pq.removeMax();
	} // end remove
		
	public T peek()
	{
		return pq.getMax();
	} // end peek

	public boolean isEmpty()
	{
		return pq.isEmpty();
	} // end isEmpty
	
	public int getSize()
	{
		return pq.getSize();
	} // end getSize

	public void clear()
	{
		pq.clear();
	} // end clear
} // end PriorityQueue